"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SignUpForm = exports.SignUpFields = void 0;
var react_1 = __importStar(require("react"));
var single_line_input_1 = __importDefault(require("primeobjects-ui-web-form/build/cjs/fields/input/single-line-input"));
var picklist_1 = __importDefault(require("primeobjects-ui-web-form/build/cjs/fields/picklist"));
var checkbox_1 = require("primeobjects-ui-web-form/build/cjs/fields/checkbox");
var message_1 = __importDefault(require("primeobjects-ui-web-form/build/cjs/fields/message"));
var core_1 = require("primeobjects-helper-util/build/cjs/core");
var lodash_1 = require("lodash");
var row_1 = __importDefault(require("primeobjects-ui-web-form/build/cjs/fields/row"));
var primeobjects_helper_ui_1 = require("primeobjects-helper-ui");
var label_1 = __importDefault(require("primeobjects-ui-web-form/build/cjs/fields/label"));
var link_1 = __importDefault(require("primeobjects-ui-web-form/build/cjs/fields/link"));
var SignUpFields = function (props) {
    var _a;
    var onChangeData = props.onChangeData, disabled = props.disabled, alwaysShowLabel = props.alwaysShowLabel, agreement = props.agreement, onShowAgreement = props.onShowAgreement;
    var data = (0, core_1.isObject)(props.data) ? props.data : {};
    var _b = (0, react_1.useState)([]), roles = _b[0], setRoles = _b[1];
    var solution = (0, primeobjects_helper_ui_1.useSolution)();
    // const primaryColor = usePrimaryColor(solution);
    (0, react_1.useEffect)(function () {
        var _a, _b;
        var signUpRoles = (_b = (_a = solution === null || solution === void 0 ? void 0 : solution.signUp) === null || _a === void 0 ? void 0 : _a.roles) !== null && _b !== void 0 ? _b : [];
        setRoles((0, lodash_1.map)(signUpRoles, function (r) {
            return { text: r.title, value: r.value };
        }));
        switch (signUpRoles.length) {
            case 0: {
                onChangeData("role", "ORG-ADMIN");
                break;
            }
            default: {
                onChangeData("role", signUpRoles[0].value);
                break;
            }
        }
    }, [(_a = solution === null || solution === void 0 ? void 0 : solution.signUp) === null || _a === void 0 ? void 0 : _a.roles]);
    var onPressEnterPassword = function () {
        if ((0, lodash_1.isFunction)(props.onSubmitPassword))
            props.onSubmitPassword(data);
    };
    var onPressEnterConfirmPassword = function () {
        if ((0, lodash_1.isFunction)(props.onSubmitConfirmPassword))
            props.onSubmitConfirmPassword(data);
    };
    var onPressEnterEmail = function () {
        if ((0, lodash_1.isFunction)(props.onSubmitEmail))
            props.onSubmitEmail(data);
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        roles.length > 1 && (react_1.default.createElement(row_1.default, null,
            react_1.default.createElement(picklist_1.default, { id: "role", labelClassName: "font-semibold", label: "Your role", options: roles, value: data.role, placeholder: "Select your role here", alwaysShowLabel: alwaysShowLabel, onChange: function (v) {
                    return onChangeData("role", v);
                } }))),
        react_1.default.createElement(row_1.default, null,
            react_1.default.createElement(single_line_input_1.default, { id: "email", labelClassName: "font-semibold", onChange: function (v) { return onChangeData("email", v); }, onSubmit: onPressEnterEmail, disabled: disabled, format: "email", borderType: "bottom", placeholder: "Type your email here", value: (0, core_1.isNonEmptyString)(data.email) ? data.email : "", alwaysShowLabel: alwaysShowLabel, label: "Your email address" })),
        react_1.default.createElement(row_1.default, null,
            react_1.default.createElement(single_line_input_1.default, { id: "password", labelClassName: "font-semibold", onSubmit: onPressEnterPassword, onChange: function (v) { return onChangeData("password", v); }, onKeyPress: onPressEnterPassword, disabled: disabled, format: "password", borderType: "bottom", placeholder: "Type your password here", label: "Your password", alwaysShowLabel: alwaysShowLabel, value: (0, core_1.isNonEmptyString)(data.password) ? data.password : "" })),
        react_1.default.createElement(row_1.default, null,
            react_1.default.createElement(single_line_input_1.default, { id: "confirmPassword", labelClassName: "font-semibold", onSubmit: onPressEnterPassword, onChange: function (v) {
                    return onChangeData("confirmPassword", v);
                }, onKeyPress: onPressEnterConfirmPassword, disabled: disabled, format: "password", borderType: "bottom", placeholder: "Confirm your password here", label: "Confirm your password", alwaysShowLabel: alwaysShowLabel, value: (0, core_1.isNonEmptyString)(data.confirmPassword)
                    ? data.confirmPassword
                    : "" })),
        agreement && agreement.title && (react_1.default.createElement(row_1.default, { className: "mt-20" },
            react_1.default.createElement(label_1.default, { id: "agreentLabel", line: "Agreement & Notice" }))),
        agreement && agreement.title && (react_1.default.createElement(row_1.default, null,
            react_1.default.createElement(link_1.default, { id: "showAgreement", type: "info", onClick: function () {
                    onShowAgreement && onShowAgreement();
                } },
                react_1.default.createElement("span", null, agreement.onClickText
                    ? agreement.onClickText
                    : "Click here to read the content")))),
        agreement && agreement.title && (react_1.default.createElement(row_1.default, null,
            react_1.default.createElement(checkbox_1.CheckboxField, { id: "signedAgreement", label: agreement.title, value: data.signedAgreement == true, onChange: function (v) {
                    onChangeData("signedAgreement", v);
                } })))));
};
exports.SignUpFields = SignUpFields;
var SignUpForm = function (props) {
    var alwaysShowLabel = props.alwaysShowLabel, agreement = props.agreement;
    var _a = (0, react_1.useState)(props.doing), doing = _a[0], setDoing = _a[1];
    var _b = (0, react_1.useState)(props.errorMessage), errorMessage = _b[0], setErrorMessage = _b[1];
    var _c = (0, react_1.useState)({}), data = _c[0], setData = _c[1];
    (0, react_1.useEffect)(function () {
        setData(props.data);
    }, [props.data]);
    (0, react_1.useEffect)(function () {
        setErrorMessage(props.errorMessage);
    }, [props.errorMessage]);
    (0, react_1.useEffect)(function () {
        if (props.doing !== doing)
            setDoing(props.doing);
    }, [props.doing]);
    var onChangeData = function (fieldName, value) {
        setErrorMessage("");
        data[fieldName] = value;
        setData(__assign({}, data));
        if (props.onChangeData)
            props.onChangeData(data);
    };
    var onSubmitConfirmPassword = function () {
        if (props.onSubmitPassword)
            props.onSubmitPassword(data);
    };
    var onShowAgreement = function () {
        props.onShowAgreement && props.onShowAgreement();
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(exports.SignUpFields, { onSubmitConfirmPassword: onSubmitConfirmPassword, onShowAgreement: onShowAgreement, alwaysShowLabel: alwaysShowLabel, data: data, onChangeData: onChangeData, disabled: doing, agreement: agreement }),
        props.children,
        react_1.default.createElement(message_1.default, { hideIcon: true, line: errorMessage, type: "error", hidden: !(0, core_1.isNonEmptyString)(errorMessage) })));
};
exports.SignUpForm = SignUpForm;
exports.default = exports.SignUpForm;
//# sourceMappingURL=sign-up.js.map