var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useEffect, useState } from "react";
import SingleLineInputField from "primeobjects-ui-web-form/build/cjs/fields/input/single-line-input";
import CheckboxField from "primeobjects-ui-web-form/build/cjs/fields/checkbox";
import { FIELD_INPUT_SIZE } from "primeobjects-ui-web-form/build/cjs/fields/types";
import MessageField from "primeobjects-ui-web-form/build/cjs/fields/message";
import { isNonEmptyString } from "primeobjects-helper-util/build/cjs/core";
import { isFunction } from "lodash";
import RowField from "primeobjects-ui-web-form/build/cjs/fields/row";
import CodesField from "primeobjects-ui-web-form/build/cjs/fields/codes";
import { getTimestamp } from "primeobjects-helper-util";
import { setLocalStorage } from "primeobjects-ui-web-basic/build/cjs/util/local-storage";
var SuccessMesaage = function (props) {
    return (React.createElement(MessageField, { wrapperClassName: "mb-4", hideIcon: true, type: "success", line: props.line, lineStyle: { fontSize: "110%", lineHeight: 1.4 } }));
};
export var SignInFields = function (props) {
    var _a;
    var onChangeData = props.onChangeData, disabled = props.disabled, alwaysShowLabel = props.alwaysShowLabel;
    var data = (_a = props.data) !== null && _a !== void 0 ? _a : {};
    //const solution = useSolution();
    // const primaryColor = usePrimaryColor(solution);
    var showCodes = data.action == "activate-with-password" ||
        data.action == "activate-without-password" ||
        data.action == "activate-reset-password" ||
        data.result == "sign-up-success";
    var onPressEnterPassword = function () {
        if (isFunction(props.onSubmitPassword))
            props.onSubmitPassword(data);
    };
    var onPressEnterEmail = function () {
        if (isFunction(props.onSubmitEmail))
            props.onSubmitEmail(data);
    };
    var onClickResendCodes = function () {
        if (isFunction(props.onClickResendCodes))
            props.onClickResendCodes(data);
    };
    var renderRememberMe = function () {
        if (data.action == "reset-password" ||
            data.action == "activate-without-password" ||
            data.action == "activate-with-password") {
            return null;
        }
        // if (!AntCheckbox) AntCheckbox = logDynamic(dynamic(() => import('../../../controls/antd/checkbox'), { ssr: false }), '../../../controls/antd/checkbox','Helper.SignInFields');
        return (React.createElement(RowField, null,
            React.createElement(CheckboxField, { id: "rememberMe", inputSize: FIELD_INPUT_SIZE.SMALL, disabled: disabled, value: data.rememberMe == true, onChange: function (v) {
                    if (!v) {
                        setLocalStorage("remember-me", "");
                    }
                    onChangeData("rememberMe", v);
                }, label: "Remember me" })));
    };
    var onKeyPress = function () {
        onChangeData("keyPressedOn", getTimestamp());
    };
    return (React.createElement(React.Fragment, null,
        (data.result == "send-verification-success" ||
            data.result == "sign-up-success") && (React.createElement(SuccessMesaage, { line: "Thank you! The verification code has been sent to your ".concat((data === null || data === void 0 ? void 0 : data.type) == "mobile"
                ? "mobile phone"
                : "email address", ".") })),
        data.result == "activate-user-without-password-success" && (React.createElement(SuccessMesaage, { line: "Thank you! Your user account has been activated successfully." })),
        data.result == "activate-user-with-password-success" && (React.createElement(SuccessMesaage, { line: "Thank you! Your password has been reset successfully." })),
        data.codeSent == "reset-password" && (React.createElement(SuccessMesaage, { line: "Thank you! The password reset link has been sent to your ".concat((data === null || data === void 0 ? void 0 : data.type) == "mobile"
                ? "mobile phone"
                : "email address", ".") })),
        React.createElement(RowField, null,
            React.createElement(SingleLineInputField, { id: "email", labelClassName: "font-semibold", onChange: function (v) { return onChangeData("email", v); }, onKeyPress: onKeyPress, onSubmit: onPressEnterEmail, disabled: disabled, format: "email", borderType: "bottom", placeholder: "Type your email here", value: isNonEmptyString(data.email) ? data.email : "", alwaysShowLabel: alwaysShowLabel, label: "Your email address" })),
        showCodes && (React.createElement(React.Fragment, null,
            React.createElement(RowField, null,
                React.createElement(CodesField, { id: "code", labelClassName: "font-semibold", onChange: function (v) { return onChangeData("code", v); }, disabled: disabled, value: isNonEmptyString(data.code) ? data.code : "", alwaysShowLabel: alwaysShowLabel, label: "Your verification code", onKeyPress: onKeyPress })),
            React.createElement(RowField, null,
                React.createElement("div", { className: "underline cursor-pointer text-sky-500 mb-4", onClick: onClickResendCodes }, "Click here to resent the verification code.")))),
        data.action != "reset-password" &&
            data.action != "activate-without-password" && (React.createElement(RowField, null,
            React.createElement(SingleLineInputField, { id: "password", labelClassName: "font-semibold", onSubmit: onPressEnterPassword, onChange: function (v) {
                    return onChangeData("password", v);
                }, onKeyPress: onKeyPress, disabled: disabled, format: "password", borderType: "bottom", placeholder: "Type your password here", label: "Your password", alwaysShowLabel: alwaysShowLabel, value: isNonEmptyString(data.password)
                    ? data.password
                    : "" }))),
        (data.action == "activate-with-password" ||
            data.action == "activate-reset-password") && (React.createElement(RowField, null,
            React.createElement(SingleLineInputField, { id: "confirmPassword", labelClassName: "font-semibold", onSubmit: onPressEnterPassword, onChange: function (v) {
                    return onChangeData("confirmPassword", v);
                }, onKeyPress: onKeyPress, disabled: disabled, format: "password", borderType: "bottom", placeholder: "Confirm your password here", label: "Confirm your password", alwaysShowLabel: alwaysShowLabel, value: isNonEmptyString(data.confirmPassword)
                    ? data.confirmPassword
                    : "" }))),
        renderRememberMe()));
};
export var SignInForm = function (props) {
    var _a, _b, _c, _d, _e;
    var alwaysShowLabel = props.alwaysShowLabel;
    var _f = useState(props.doing), doing = _f[0], setDoing = _f[1];
    var _g = useState(props.errorMessage), errorMessage = _g[0], setErrorMessage = _g[1];
    var _h = useState({}), data = _h[0], setData = _h[1];
    useEffect(function () {
        setData(props.data);
    }, [props.data]);
    useEffect(function () {
        setErrorMessage(props.errorMessage);
    }, [props.errorMessage]);
    useEffect(function () {
        setDoing(props.doing);
    }, [props.doing]);
    var onChangeData = function (fieldName, value) {
        setErrorMessage("");
        data[fieldName] = value;
        setData(__assign({}, data));
        if (isFunction(props.onChangeData))
            props.onChangeData(data);
    };
    var onSubmitPassword = function () {
        if (isFunction(props.onSubmitPassword))
            props.onSubmitPassword(data);
    };
    var onSubmitEmail = function () {
        if (isFunction(props.onSubmitEmail))
            props.onSubmitEmail(data);
    };
    var onClickResendCodes = function () {
        if (isFunction(props.onClickResendCodes))
            props.onClickResendCodes(data);
    };
    return (React.createElement(React.Fragment, null,
        isNonEmptyString((_a = props.message) === null || _a === void 0 ? void 0 : _a.contnet) && (React.createElement(MessageField, { wrapperClassName: "mb-4", hideIcon: true, line: (_b = props.message) === null || _b === void 0 ? void 0 : _b.contnet, type: ((_c = props.message) === null || _c === void 0 ? void 0 : _c.type) ? (_d = props.message) === null || _d === void 0 ? void 0 : _d.type : "success", hidden: !isNonEmptyString((_e = props.message) === null || _e === void 0 ? void 0 : _e.contnet) })),
        React.createElement(SignInFields, { onClickResendCodes: onClickResendCodes, onSubmitPassword: onSubmitPassword, onSubmitEmail: onSubmitEmail, alwaysShowLabel: alwaysShowLabel, data: data, onChangeData: onChangeData, disabled: doing }),
        props.children,
        React.createElement(MessageField, { hideIcon: true, line: errorMessage, type: "error", hidden: !isNonEmptyString(errorMessage) })));
};
export default SignInForm;
//# sourceMappingURL=sign-in.js.map